# Tips for Apple App Store Review with Passwordless Login

When you try to publish a mobile app on the Apple AppStore, there will be an [App Review process](https://developer.apple.com/app-store/review/). You need provide a demo user account for the reviewers to access the features of the app.

However, passwordless login via email/phone OTP cannot be used in the review because the reviewer do not have access to the email inbox or phone number of that demo account.

To work around this, you can enable "test mode" for a specific phone number or email address that allows the account to authenticate with a fixed OTP (e.g. `000000`).

## How to enable "test mode"

1. Navigate to Advanced > Edit Config
2. paste the following to the yaml:

```yaml
test_mode:
  oob_otp:
    enabled: true
    rules:
    - fixed_code: "000000"
      regex: (\+85291231234$|me@example\.com$)
  sms:
    enabled: true
    rules:
    - suppressed: true
      regex: \+85291231234$
  whatsapp:
    enabled: true
    rules:
    - suppressed: true
      regex: \+85291231234$
  email: 
    enabled: true
    rules:
    - suppressed: true
      regex: me@example\.com$
```

In this example,

* `+85291231234` and `me@example.com` will not recieve any messages.
* They can log in using the fixed OTP `000000`.
* All other users will continue to receive OTPs normally.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.authgear.com/faq-for-authentication/passwordless-demo-user-for-apple-app-review.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
